/***************************************************
//Web: http://www.buydisplay.com
EastRising Technology Co.,LTD
Examples for ER-TFT034-1 Capacitive touch screen test
Display is Hardward SPI 4-Wire SPI Interface and 5V Power Supply,CTP is I2C interface.
Tested and worked with:
Works with Arduino 1.6.0 IDE  
Test ok: Arduino UNO,Arduino MEGA2560 ,Arduino DUE
If using the DUE board, please disconnect the metal pins of IO0 and IO1, 
and connect the adapter board's IO0 to IO11, IO1 to IO13,and modify the IO definition in the LCD_init.H file
****************************************************/
#include <SPI.h>
#include <Wire.h>
#include "LCD.h"
#include "LCD_init.h"
#include <stdint.h>
#include "Arduino.h"
#include "Print.h"

uint8_t addr  = 0x1A;  //CTP IIC ADDRESS

#define CST340_RST 6
#define CST340_INT   7  

#define HYN_REG_MUT_DEBUG_INFO_MODE             0xD101
#define HYN_REG_MUT_RESET_MODE            		0xD102
#define HYN_REG_MUT_DEEP_SLEEP_MODE    			0xD105
#define HYN_REG_MUT_NORMAL_MODE                0xD109
#define HYN_REG_MUT_DEBUG_INFO_IC_CHECKSUM             0xD208
#define HYN_REG_MUT_DEBUG_INFO_FW_VERSION              0xD204
#define HYN_REG_MUT_DEBUG_INFO_RES_Y            	   0xD1FA
#define HYN_REG_MUT_DEBUG_INFO_RES_X            	   0xD1F8
#define GTP_READ_COOR_ADDR    0xD000

struct _ts_event
{
    uint8_t     touch_pressure;	
    uint8_t     touch_point;
	
};
struct _ts_event ts_event; 


struct TouchLocation
{
  uint16_t x;
  uint16_t y;
};

TouchLocation touchLocations[5];

	
uint8_t buf[30];


void inttostr(uint16_t value,uint8_t *str);
void writeCST340TouchRegister( uint16_t regAddr,uint8_t *val, uint16_t cnt);
uint8_t readCST340TouchAddr( uint16_t regAddr, uint8_t * pBuf, uint8_t len );
uint8_t readCST340TouchLocation( void);



void writeCST340TouchRegister( uint16_t regAddr,uint8_t *val, uint16_t cnt)
{	uint16_t i=0;
  Wire.beginTransmission(addr);
   Wire.write( regAddr>>8 );  // register 0
  Wire.write( regAddr);  // register 0 
	for(i=0;i<cnt;i++,val++)//data
	{		
          Wire.write( *val );  // value
	}
  uint8_t retVal = Wire.endTransmission(); 
}



uint8_t readCST340TouchAddr( uint16_t regAddr, uint8_t * pBuf, uint8_t len )
{
  Wire.beginTransmission(addr);
  Wire.write( regAddr>>8 );  // register 0
  Wire.write( regAddr);  // register 0  
  uint8_t retVal = Wire.endTransmission();
  
  uint8_t returned = Wire.requestFrom(addr, len);    // request 1 bytes from slave device #2
  
  uint8_t i;
  for (i = 0; (i < len) && Wire.available(); i++)
  
  {
    pBuf[i] = Wire.read();
  }
  
  return i;
}

uint8_t readCST340TouchLocation( void)
{
  uint8_t retVal;
  uint8_t i;
  uint8_t k;
  uint8_t  ss[1];
  do
  {    
     ss[0]=0;
      readCST340TouchAddr(GTP_READ_COOR_ADDR,buf,28);
    ts_event.touch_point = buf[5]&0x0F;
    if (ts_event.touch_point == 0) break; // no points detected
   ts_event.touch_pressure= buf[4];

    
   if  (ts_event.touch_point==1)                       
        {
          touchLocations[0].x =(uint16_t)(buf[1])<<4 | (uint16_t)buf[3]>>4&0x0F;;  
          touchLocations[0].y = (uint16_t)(buf[2])<<4 | (uint16_t)buf[3]&0x0F;  
        }   
   if  (ts_event.touch_point==2)                   
        {touchLocations[0].x =(uint16_t)(buf[1])<<4 | (uint16_t)buf[3]>>4&0x0F;;  
          touchLocations[0].y = (uint16_t)(buf[2])<<4 | (uint16_t)buf[3]&0x0F;
          touchLocations[1].x =(uint16_t)(buf[8] )<<4 | (uint16_t)buf[10]>>4&0x0F;;
          touchLocations[1].y =(uint16_t)(buf[9] )<<4 | (uint16_t)buf[10]&0x0F;
        }  
    if  (ts_event.touch_point==3)                   
        {touchLocations[0].x =(uint16_t)(buf[1])<<4 | (uint16_t)buf[3]>>4&0x0F;;  
          touchLocations[0].y = (uint16_t)(buf[2])<<4 | (uint16_t)buf[3]&0x0F;
          touchLocations[1].x =(uint16_t)(buf[8] )<<4 | (uint16_t)buf[10]>>4&0x0F;;
          touchLocations[1].y =(uint16_t)(buf[9] )<<4 | (uint16_t)buf[10]&0x0F;        
          touchLocations[2].x =(uint16_t)(buf[13] )<<4 | (uint16_t)buf[15]>>4&0x0F;
          touchLocations[2].y = (uint16_t)(buf[14] )<<4 | (uint16_t)buf[15]&0x0F;
        }    
    if  (ts_event.touch_point==4)                   
        {touchLocations[0].x =(uint16_t)(buf[1])<<4 | (uint16_t)buf[3]>>4&0x0F;;  
          touchLocations[0].y = (uint16_t)(buf[2])<<4 | (uint16_t)buf[3]&0x0F;
          touchLocations[1].x =(uint16_t)(buf[8] )<<4 | (uint16_t)buf[10]>>4&0x0F;;
          touchLocations[1].y =(uint16_t)(buf[9] )<<4 | (uint16_t)buf[10]&0x0F;        
          touchLocations[2].x =(uint16_t)(buf[13] )<<4 | (uint16_t)buf[15]>>4&0x0F;
          touchLocations[2].y = (uint16_t)(buf[14] )<<4 | (uint16_t)buf[15]&0x0F;
          touchLocations[3].x =(uint16_t)(buf[18] )<<4 | (uint16_t)buf[20]>>4&0x0F; 
          touchLocations[3].y =(uint16_t)(buf[19] )<<4 | (uint16_t)buf[20]&0x0F;
        }   
     if  (ts_event.touch_point==5)                   
        {touchLocations[0].x =(uint16_t)(buf[1])<<4 | (uint16_t)buf[3]>>4&0x0F;;  
          touchLocations[0].y = (uint16_t)(buf[2])<<4 | (uint16_t)buf[3]&0x0F;
          touchLocations[1].x =(uint16_t)(buf[8] )<<4 | (uint16_t)buf[10]>>4&0x0F;;
          touchLocations[1].y =(uint16_t)(buf[9] )<<4 | (uint16_t)buf[10]&0x0F;        
          touchLocations[2].x =(uint16_t)(buf[13] )<<4 | (uint16_t)buf[15]>>4&0x0F;
          touchLocations[2].y = (uint16_t)(buf[14] )<<4 | (uint16_t)buf[15]&0x0F;
          touchLocations[3].x =(uint16_t)(buf[18] )<<4 | (uint16_t)buf[20]>>4&0x0F; 
          touchLocations[3].y =(uint16_t)(buf[19] )<<4 | (uint16_t)buf[20]&0x0F;
          touchLocations[4].x =(uint16_t)(buf[23] )<<4 | (uint16_t)buf[25]>>4&0x0F;
          touchLocations[4].y =(uint16_t)(buf[24] )<<4 | (uint16_t)buf[25]&0x0F;
        }  
  
    retVal = ts_event.touch_point;
    
  } while (0);
  
  return retVal;
}

void inttostr(uint16_t value,uint8_t *str)
{
	str[0]=value/1000+0x30;
	str[1]=value%1000/100+0x30;
	str[2]=value%1000%100/10+0x30;
	str[3]=value%1000%100%10+0x30;

}



void setup() {uint8_t ss[4];

  Wire.begin();        // join i2c bus (address optional for master)   


   delay(100);
  ER5517.Parallel_Init();
  ER5517.HW_Reset();
  ER5517.System_Check_Temp();
  delay(100);
  while(ER5517.LCD_StatusRead()&0x02);
  ER5517.initial();
  ST7701S_Initial(); 
  ER5517.Display_ON();

  ER5517.Select_Main_Window_16bpp();
  ER5517.Main_Image_Start_Address(layer1_start_addr);        
  ER5517.Main_Image_Width(LCD_XSIZE_TFT);
  ER5517.Main_Window_Start_XY(0,0);
  ER5517.Canvas_Image_Start_address(0);
  ER5517.Canvas_image_width(LCD_XSIZE_TFT);
  ER5517.Active_Window_XY(0,0);
  ER5517.Active_Window_WH(LCD_XSIZE_TFT,LCD_YSIZE_TFT); 
  
  ER5517.Foreground_color_65k(Black);
  ER5517.Line_Start_XY(0,0);
  ER5517.Line_End_XY(LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1);
  ER5517.Start_Square_Fill(); 
  
   ER5517.Foreground_color_65k(White);
  ER5517.Background_color_65k(Black);
  ER5517.CGROM_Select_Internal_CGROM();  
  ER5517.Font_Select_8x16_16x16();
  ER5517.Goto_Text_XY(0,0); 
  ER5517.Show_String( "www.buydisplay.com");   
  ER5517.Goto_Text_XY(0,16); 
  ER5517.Show_String( "Capacitive touch screen tese"); 
  ER5517.Goto_Text_XY(5,LCD_YSIZE_TFT-25); 
  ER5517.Show_String( "Clear");   

    
    pinMode(CST340_RST, OUTPUT); 
    pinMode     (CST340_INT, INPUT);
    digitalWrite(CST340_RST, LOW);
    delay(20);
    digitalWrite(CST340_RST, HIGH);
    delay(50);
    writeCST340TouchRegister(HYN_REG_MUT_RESET_MODE,0 ,0);	  
    writeCST340TouchRegister(HYN_REG_MUT_NORMAL_MODE ,0 ,0);  
 
}
void loop() {
   static uint16_t w = LCD_XSIZE_TFT;
  static uint16_t h = LCD_YSIZE_TFT; 
   unsigned int i;
   double float_data;  
  
      pinMode     (CST340_INT, INPUT);  
  
  while(1) 
  { 
  
       uint8_t st=digitalRead(CST340_INT);       
      if(!st)    //Hardware touch interrupt
    {  
      Serial.println("Touch: ");
      
        readCST340TouchLocation();
                
        for (i = 0; i < ts_event.touch_point; i++)
          {  
            
            if (((touchLocations[i].x)<50) &&((touchLocations[i].y)>LCD_YSIZE_TFT-30))
              {    ER5517.Foreground_color_65k(Black);
                  ER5517.Line_Start_XY(0,0);
                  ER5517.Line_End_XY(LCD_XSIZE_TFT-1,LCD_YSIZE_TFT-1);
                  ER5517.Start_Square_Fill(); 
                  
                   ER5517.Foreground_color_65k(White);
                  ER5517.Background_color_65k(Black);
                  ER5517.CGROM_Select_Internal_CGROM();  
                  ER5517.Font_Select_8x16_16x16();
                  ER5517.Goto_Text_XY(0,0); 
                  ER5517.Show_String( "www.buydisplay.com");   
                  ER5517.Goto_Text_XY(0,16); 
                  ER5517.Show_String( "Capacitive touch screen test"); 
                  ER5517.Goto_Text_XY(5,LCD_YSIZE_TFT-25); 
                  ER5517.Show_String( "Clear");                  
              }  
             
          else{ 
         snprintf((char*)buf,sizeof(buf),"(%3d,%3d)",touchLocations[i].x,touchLocations[i].y);                 
            const  char *str=(const char *)buf;
             ER5517.Foreground_color_65k(White>>(i*3));  
            ER5517.Text_Mode();
            ER5517.Goto_Text_XY(50,80+16*i);
            ER5517.LCD_CmdWrite(0x04);
            while(*str != '\0')
            {
            ER5517.LCD_DataWrite(*str);
            ER5517.Check_Mem_WR_FIFO_not_Full();      
            ++str; 
            } 
            ER5517.Check_2D_Busy();
            ER5517.Graphic_Mode(); //back to graphic mode;
 
             if(i==0)  ER5517.DrawCircle_Fill(touchLocations[i].x,touchLocations[i].y, ts_event.touch_pressure/12, Red);  
            else if(i==1)  ER5517.DrawCircle_Fill(touchLocations[i].x,touchLocations[i].y, ts_event.touch_pressure/12, Green); 
            else if(i==2)  ER5517.DrawCircle_Fill(touchLocations[i].x,touchLocations[i].y,ts_event.touch_pressure/12, Blue);        
            else if(i==3)  ER5517.DrawCircle_Fill(touchLocations[i].x,touchLocations[i].y, ts_event.touch_pressure/12, Cyan); 
             else if(i==4)  ER5517.DrawCircle_Fill(touchLocations[i].x,touchLocations[i].y, ts_event.touch_pressure/12, Yellow);     
           
         
  
          }
        }
     }

    
  }
 
}



